#!/bin/sh
#################################################
# Mongoose's C++ template script 
#
# Note that the order of the sed command, and
# you can see that you can even use the
# vars in your personalized files and sh args
#
# - Mongoose<stu7440@westga.edu>
#################################################

DEVELOPER=$USER
PROJECT=$1
CLASS=$2
DESC=$3
HELP="   template.sh PROJECT CLASS [ \"CLASS DESCRIPTION\" ]"

if [ -f ~/scripts/template.cfg ]
then
    source ~/scripts/template.cfg 
else
    echo
    echo $HELP
    echo "   DEVELOPER Profile '~/scripts/template.cfg' does not exist!"
    echo
    exit 0    
fi

if [ $CLASS ]
then
    echo
    echo Generating $CLASS.cpp and $CLASS.h
    echo
else
    echo
    echo $HELP
    echo
    exit 0
fi

# Generate header file from template
sed -e "s/#Comment/$DESC/g;s/#License/`echo $LICENSE`/g;s/#Email/`echo $EMAIL`/g;s/#Url/`echo $URL`/g;s/#User/`echo $DEVELOPER`/g;s/#Class/$CLASS/g;s/#Project/$PROJECT/g;s/#PROJECT/`echo $PROJECT | tr [a-z] [A-Z]`/g;s/#CLASS/`echo $CLASS | tr [a-z] [A-Z]`/g;s/#USER/`echo $DEVELOPER | tr [a-z] [A-Z]`/g;s/#DAY/`date +"%d"`/g;s/#MONTH/`date +"%m"`/g;s/#YEAR/`date +"%Y"`/g" $HEADER_TEMPLATE > $CLASS.h

# Generate source file from template
sed -e "s/#Comment/$DESC/g;s/#License/`echo $LICENSE`/g;s/#Email/`echo $EMAIL`/g;s/#Url/`echo $URL`/g;s/#User/`echo $DEVELOPER`/g;s/#Class/$CLASS/g;s/#Project/$PROJECT/g;s/#PROJECT/`echo $PROJECT | tr [a-z] [A-Z]`/g;s/#CLASS/`echo $CLASS | tr [a-z] [A-Z]`/g;s/#USER/`echo $DEVELOPER | tr [a-z] [A-Z]`/g;s/#DAY/`date +"%d"`/g;s/#MONTH/`date +"%m"`/g;s/#YEAR/`date +"%Y"`/g" $CPP_TEMPLATE > $CLASS.cpp
